<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.ruoyi.system.mapper.ClockUserInfoMapper">
    
    <resultMap type="ClockUserInfo" id="ClockUserInfoResult">
        <result property="userId"    column="user_id"    />
        <result property="deptId"    column="dept_id"    />
        <result property="deptName"    column="dept_name"    />
        <result property="userName"    column="user_name"    />
        <result property="phonenumber"    column="phonenumber"    />
        <result property="idCard"    column="id_card"    />
        <result property="delFlag"    column="del_flag"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectClockUserInfoVo">
        select user_id, dept_id, dept_name, user_name, phonenumber, id_card, del_flag, create_by, create_time, update_by, update_time, remark from clock_user_info
    </sql>

    <select id="selectClockUserInfoList" parameterType="ClockUserInfo" resultMap="ClockUserInfoResult">
        <include refid="selectClockUserInfoVo"/>
        <where>  
            <if test="deptId != null "> and dept_id = #{deptId}</if>
            <if test="deptName != null "> and dept_name like concat('%', #{deptName}, '%')</if>
            <if test="userName != null  and userName != ''"> and user_name like concat('%', #{userName}, '%')</if>
            <if test="phonenumber != null  and phonenumber != ''"> and phonenumber = #{phonenumber}</if>
            <if test="idCard != null  and idCard != ''"> and id_card = #{idCard}</if>
        </where>
    </select>
    
    <select id="selectClockUserInfoByUserId" parameterType="Long" resultMap="ClockUserInfoResult">
        <include refid="selectClockUserInfoVo"/>
        where user_id = #{userId}
    </select>
        
    <insert id="insertClockUserInfo" parameterType="ClockUserInfo" useGeneratedKeys="true" keyProperty="userId">
        insert into clock_user_info
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="deptId != null">dept_id,</if>
            <if test="deptName != null">dept_name,</if>
            <if test="userName != null and userName != ''">user_name,</if>
            <if test="phonenumber != null">phonenumber,</if>
            <if test="idCard != null">id_card,</if>
            <if test="delFlag != null">del_flag,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="deptId != null">#{deptId},</if>
            <if test="deptName != null">#{deptName},</if>
            <if test="userName != null and userName != ''">#{userName},</if>
            <if test="phonenumber != null">#{phonenumber},</if>
            <if test="idCard != null">#{idCard},</if>
            <if test="delFlag != null">#{delFlag},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateClockUserInfo" parameterType="ClockUserInfo">
        update clock_user_info
        <trim prefix="SET" suffixOverrides=",">
            <if test="deptId != null">dept_id = #{deptId},</if>
            <if test="deptName != null">dept_name = #{deptName},</if>
            <if test="userName != null and userName != ''">user_name = #{userName},</if>
            <if test="phonenumber != null">phonenumber = #{phonenumber},</if>
            <if test="idCard != null">id_card = #{idCard},</if>
            <if test="delFlag != null">del_flag = #{delFlag},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where user_id = #{userId}
    </update>

    <delete id="deleteClockUserInfoByUserId" parameterType="Long">
        delete from clock_user_info where user_id = #{userId}
    </delete>

    <delete id="deleteClockUserInfoByUserIds" parameterType="String">
        delete from clock_user_info where user_id in 
        <foreach item="userId" collection="array" open="(" separator="," close=")">
            #{userId}
        </foreach>
    </delete>
</mapper>